      SUBROUTINE FFCALD
CCCCCC
      PARAMETER(NHS=9,NPS=9,LXA=150,LXB=150,LPH=20,LMM=4,LTL=9,LM1=5)
      PARAMETER(NXA=420,NXB=140,NIN=300,N1X=140,KGG=125,KAA=40)
      PARAMETER(KFM=10,KCC=80,LMJ=10,KJL=600,L1X=10)
CCCCCC      
      COMMON/CNST  /FACLOG(500),PI,HBAR,AMAS,WNUNIT,FINE 
      COMMON/CNTRL/ KTRLD(9),KTLOUT(24),KRTYPE
      COMMON/SPSTAT/EET,SPECTA(LPH),ESP(LPH),ESH(LPH),NSP(LPH),LSP(LPH),
     1              JTWP(LPH),NSH(LPH),LSH(LPH),JTWH(LPH),IPAIR,NOSP,
     2              NOSH,NPST(LPH),NHST(LPH),NPAIRD,L1R(8),ISR(8),
     3              ITR(8),NLSMAX,JT,MJMAX,KPARIT,IST,NOLTR,N1,LTR(8),
     4              ITP(LPH),ITH(LPH),ITZP(LPH),ITZH(LPH)
      COMMON/CBST/  USAVP(NPS*NXA),USAVH(NHS*NXA)
      COMMON/DWCC/  LDWMIR(4),LDWMXR(4),WN(4),LDWSTR(4),CE(4),CFUNIR(4),
     1              ECM(4),XMESR(4),NXMXR(4),NXMIR(4),NOEXP,MXSTEP,
     2              TMASA,TMASB,TMASX,TMASY,PMASA,PMASB,PMASX,PMASY,
     3              TZA,TZB,TZX,TZY,
     4              PZA,PZB,PZX,PZY,XBARD(4),XBARID(4)
      COMMON/SPECFC/ALPHA(30,6)
      COMMON/FFCC/  VRANG(6),VSTR(12,6),VV(NIN,12),XMESH,XMESHD,XMESHE,
     1              RHED(NIN),NBCMI,NBCMX,NONB,NBSTEP,LASTEP,LBSTEP,
     2              MXMAX,MP1MAX,NOLA,NOLB,INTRAN,KCETN(2),NONA,NONAH,
     3              NONAR,NASTEP,NHDMX,NHEMX,NGAUSR,NBSTPD,NBSTPE,
     4              N1STEP,JATW,ISATW
      COMMON/CDENS/ RHOD(NXA,NIN,LMM),USAVEX(4*NXA),SPEC(4),
     1              DENSTY(NXA),LAMMXD(3),LBXD(4),NOSTX
      COMMON/CCKF/  L1KFD(KFM),ISKFD(KFM),KKFD(KFM),LTKFD(KFM),KFMAX,
     1              ITKFD(KFM),NLSKFD(KFM),NLTKFD(KFM),LTMIM,LTMAX
      COMMON/CGGR/  GGRI(L1X,N1X)
      COMPLEX       GGRI
CCCCCC
      DIMENSION     CLEBQ(KCC,5),P(130,30),PP(130,10)
      DIMENSION     RTS(96),WGT(96)
      DIMENSION     L9(10)
      DIMENSION     AF(500),AFI(500),XAF(500),XIAF(500),FSP(500),
     1              FSPI(500),Q1(500),AU(500)
      DIMENSION     RHOT(NIN,LMM),TRHO(NXA,5),PD(LMM*LMM),QA(KFM,NIN)
      COMPLEX       ZERO,TTI,URI1,URI2,URI3
      DOUBLE PRECISION   FFMU,RROOT,FFMU2
CCCCCC
      WRITE(8,830)
  830 FORMAT(//1H ,'FFCALD IS CALLED')
      WRITE(8,831)
  831 FORMAT(1H ,5X,'INPUT INFORMATION FOR DIRECT FORM FACTOR')
      WRITE(8,833) NXMIR(4),NXMXR(4),N1STEP,XMESR(4)
  833 FORMAT(1H ,5X,'N1MIN,N1MAX,N1STEP,XEMSH=',3I5,F10.3)
      WRITE(8,835) NBCMI,NBCMX,NBSTEP,XMESR(2)
  835 FORMAT(1H ,5X,'NBMIN,NBMAX,NBSTEP,XEMSH=',3I5,F10.3)
      IF (NBSTEP.NE.1) WRITE(8,836)
  836 FORMAT(1H ,5X,'**INTERPOLATION IN R_B IS MADE')
      WRITE(8,837) INTRAN,XMESHD
  837 FORMAT(1H ,5X,'INTRAN,XMESHD=',16X,I5,5X,F10.3)
      WRITE(8,832) MXMAX
  832 FORMAT(1H ,5X,'MXMAX=',19X,5I5)
CCCCCC 
CCCCCC     SECTION 1. EFFECTIVE INTERACTION
CCCCCC	
      CALL EFFINT(0)
CCCCCC
CCCCCC     SECTION 2. PROJECTILE DENSITY
CCCCCC
      CALL PDENST(0)
CCCCCC
CCCCCC     SECTION 3. TARGET DENSITY
CCCCCC
      ZERO=(0.0,0.0)
      TTI=(0.0,1.0)
      KMAS=PMASA+0.001
      IF (KTRLD(1).EQ.3) KMAS=1
      IF (KMAS.EQ.1) N1MAX=NBCMX
      LAP1MI=LDWMIR(1)+1
      LAP1MX=LDWMXR(1)+1
      LASTEP=LDWSTR(1)
      LBP1MI=LDWMIR(2)+1
      LBP1MX=LDWMXR(2)+1
      LBSTEP=LDWSTR(2)
      NOLA=(LAP1MX-LAP1MI)/LASTEP+1
      NOLB=(LBP1MX-LBP1MI)/LBSTEP+1
      XMESA=XMESR(1)
      NMXA=NXMXR(1)
      NMIA=NXMIR(1)
      XMESX=XMESR(3)
      NMXX=NXMXR(3)
      NMIX=NXMIR(3)
      XMES1=XMESR(4)
      N1MAX=NXMXR(4)
      IF (KMAS.EQ.1) N1MAX=NBCMX
      N1MIN=NXMIR(4)
      XMESB=XMESR(2)
      NMXB=NXMXR(2)
      NMIB=NXMIR(2)
      NONB=(NBCMX-NBCMI)/NBSTEP+1
      NBCMX=(NONB-1)*NBSTEP+NBCMI
      NONA=NMXA-NMIA+1
      NONX=NMXX-NMIX+1
      NONY=N1MAX-N1MIN+1
      XMESX3=XMESX/3.0
      XMESH3=XMESH/3.0
      XMES13=XMES1/3.0
      XMESA3=XMESA/3.0
      R2MX=XMESX*FLOAT(NMXX)
      IF(KMAS.EQ.1) R2MX=XMESH*FLOAT(INTRAN)  !NUCLEON SCATTERING
      R2MXSQ=R2MX*R2MX
CCCCCC
CCCCC        CALCULATIONS OF TRANSITION DENSITIES
CCCCCC
      LAM1MX=1
      LAM2MX=3
      KBMAXT=NLSMAX
      DO 35 KB=1,KBMAXT
      DO 35 N1=1,N1MAX
   35 TRHO(N1,KB)=0.0
      JTTW=JT*2
      ITZ1=PZA-PZB+0.01
      DO 80 NLS=1,NLSMAX
      IS=ISR(NLS)
      ISTW=IS*2
      L1=L1R(NLS)
      IT1=ITR(NLS)
      L1TW=L1*2
      NPAIR=NPAIRD
      DO 56 I=1,NPAIR
      NP1=NPST(I)
      NH1=NHST(I)
      A1=SPECTA(I)
      N1BASE=(NP1-1)*N1MAX
      N2BASE=(NH1-1)*N1MAX
      LP=LSP(NP1)
      LH=LSH(NH1)
      K1=LP+LH+L1
      IF(MOD(K1,2).NE.0) GO TO 56
      LPTW=LP*2
      LHTW=LH*2
      JPTW=JTWP(NP1)
      JHTW=JTWH(NH1)
      L9(1)=LPTW
      L9(2)=1
      L9(3)=LHTW
      L9(4)=1
      L9(5)=JPTW
      L9(6)=JHTW
      L9(7)=L1TW
      L9(8)=ISTW
      L9(9)=JTTW
      CALL NINEJ(L9,FACLOG,U9)
      T1=U9
      H1=(JPTW+1)*(JHTW+1)*(L1TW+1)*(ISTW+1)
      U9=T1*SQRT(H1)
      PHASE=1.0
      IF(IT1.EQ.1.AND.ITZ1.EQ.0.AND.ITZP(NP1).EQ.-1)  PHASE=-1.0
      IA=LPTW
      IB=LHTW
      IC=L1TW
      H1=FLOAT((IA+1)*(IB+1))/FLOAT(IC+1)
      HAT=SQRT(H1)
      CALL CLEBZ(IA,IB,IC,FACLOG,RAC)
      C1=RAC
      K1=-KPARIT
      S1=1.0
      FAC1=A1*U9*S1*C1*HAT
      NCORR=LP
      PHACO=1-2*MOD(NCORR,2)
      FAC1=FAC1*PHACO
      FAC1P=U9*S1*C1*HAT*PHASE*PHACO
      DO 40 N1=1,N1MAX
      N1M=N1+N1BASE
      N2M=N1+N2BASE
      TRHO(N1,NLS)=TRHO(N1,NLS)+USAVP(N1M)*USAVH(N2M)*FAC1*PHASE
   40 CONTINUE
   56 CONTINUE
CCCCCC
      IF (KTLOUT(3).NE.0) THEN
      WRITE(8,871)
      WRITE(8,872) NLS,(TRHO(N1,NLS),N1=10,N1MAX,10)
      ENDIF
  871 FORMAT(/1H ,'TRHO(N1,NLS)= (AT N1=10,NIMAX,10)')
  872 FORMAT(1H ,'NLS=',I3,10E10.3/(8X,10E10.3))
CCCCCC
   80 CONTINUE
CCCCCC
CCCCCC      SECTION 4. A FACTOR WITH M AND SUMS OVER LT AND L1
CCCCCC
      L1MAX=L1R(1)
      DO 90 NLS=1,NLSMAX
      IF(L1MAX.LT.L1R(NLS)) L1MAX=L1R(NLS)
   90 CONTINUE
      M2MAX=LAM2MX
      LPP1MX=L1MAX+1
      KF=0
      LTMIN=LTR(1)
      LTMAX=LTR(NOLTR)
      NLSKMX=NLSMAX*2
      DO 95 NLT=1,NOLTR
      LT=LTR(NLT)
      LTTW=LT*2
      DO 94 NLSK=1,NLSKMX
      K1=(NLSK-1)/NLSMAX
      K=K1*2
      NLS=NLSK-NLSMAX*K1
      IS=ISR(NLS)
      L1=L1R(NLS)
      KTWP1=K*2+1
      IF(LT.GT.(K+L1).OR.LT.LT.IABS(K-L1)) GO TO 94
      IF(K.EQ.2.AND.IS.EQ.0)               GO TO 94
      KF=KF+1
      ITKFD(KF)=ITR(NLS)
      L1KFD(KF)=L1
      ISKFD(KF)=IS
      KKFD(KF)=K
      LTKFD(KF)=LT
      NLSKFD(KF)=NLS
      NLTKFD(KF)=NLT
      T1=LT*2+1
      T2=KTWP1
      FAC1=PI*2.0*SQRT(T1)/T2
      IF(MOD(LT+L1+K,2).NE.0) FAC1=0.0
      M1X=MIN0(K+1,L1+1)
      F1=1.0
      DO 92 M1=1,M1X
      IA=LT*2
      IB=L1*2
      IC=K *2
      ID=0
      IE=(M1-1)*2
      IFF=IE
      CALL CLEB(IA,IB,IC,ID,IE,IFF,FACLOG,RAC)
      IF(M1.GT.1) F1=2.0
      CLEBQ(KF,M1)=RAC*FAC1*F1*ALPHA(NLSK,NLT)
   92 CONTINUE
   94 CONTINUE
   95 CONTINUE
      KFMAX=KF
CCCCCC
      IF (KTLOUT(3).GE.2) THEN
      WRITE(8,875) KFMAX,LTMIN,LTMAX,LAM2MX,LPP1MX,MP1MAX
  875 FORMAT(/1H ,'KFMAX,LTMIN,LTMAX,LAM2MX,LPP1MX,MP1MAX=',6I4)
      ENDIF
CCCCC
CCCCC       SECTION 5. PREPARE GAUSSIAN INTEGRATION
CCCCC
      NGAUS=NGAUSR
      CALL GAUSF(NGAUS,RTS,WGT)
CCCCC
CCCCC       SECTION 6. DIRECT FORM FACTOR
CCCCC                  [BIG NB-LOOP STARTS(UP TO 900)]
CCCCC
      NBM=0
      DO 900 NB=NBCMI,NBCMX,NBSTEP
      NBM=NBM+1
      RB=XMESB*FLOAT(NB)
      RBSQ=RB*RB
CCCCC
CCCCC                N1-LOOP(UP TO 300)
CCCCC
      DO 102 KF=1,KFMAX
      DO 102 NH=1,INTRAN
      QA(KF,NH)=0.0
  102 CONTINUE
CCCCC
      F1=2.0
      XMES13=XMES1/3.0
      DO 300 N1=1,N1MAX
      R1=XMES1*FLOAT(N1)
      AB1=ABS(R1-RB)
      IF(AB1.GE.R2MX) GO TO 300
      R1SQ=R1*R1
      F1=6.0-F1
      FAC1=R1SQ*XMES13*F1
      R1RB2=R1*RB*2.0
CCCCC
      IF(KMAS.EQ.1) GO TO 200
CCCCC
      FMUI=(R1SQ+RBSQ-R2MXSQ)/R1RB2
      IF(FMUI.GT.1.0) GO TO 300
      IF(FMUI.LT.-1.0) FMUI=-1.0
      RANGE=1.0-FMUI
      RANG2=RANGE*0.5
CCCCC
      DO 190 NG=1,NGAUS
      ROOT=1.0-(1.0-RTS(NG))*RANG2
      WGT1=WGT(NG)*RANG2
      FAC2=WGT1*FAC1
      R2SQ=R1SQ+RBSQ-R1RB2*ROOT
      R2=SQRT(R2SQ)
      X2=R2/XMESX
      N2=X2
      IF(N2.LT.1) N2=1
      IF(N2.GT.NMXX-1) GO TO 190
      FN2=N2
      FMU=(R1*ROOT-RB)/R2
      FFMU=FMU
      CALL YLCAL(FFMU,LAM2MX,LAM2MX,P)
      J=0
      DO 124 K1=1,LAM2MX
      DO 124 M1=1,K1
      J=J+1
      PD(J)=P(K1,M1)
  124 CONTINUE
      RROOT=ROOT
      CALL YLCAL(RROOT,LPP1MX,LPP1MX,P)
      DO 125 LAM2P1=1,LAM2MX
      DO 125 NH=1,INTRAN
      RHOT1=RHOD(N2  ,NH,LAM2P1)
      RHOT2=RHOD(N2+1,NH,LAM2P1)
      RHOT(NH,LAM2P1)=RHOT1+(RHOT2-RHOT1)*(X2-FN2)
 125  CONTINUE
      DO 130 KF=1,KFMAX
      NLS=NLSKFD(KF)
      LP1=L1KFD(KF)+1
      KP1=KKFD(KF)+1
      M2X=MIN0(KP1,LP1)
      DO 128 M2=1,M2X
      C1=CLEBQ(KF,M2)
      K2=(KP1*(KP1-1))/2+M2
      FAC3=FAC2*PD(K2)*P(LP1,M2)*C1
      DO 126 NH=1,INTRAN
      QA(KF,NH)=QA(KF,NH)+TRHO(N1,NLS)*RHOT(NH,KP1)*FAC3
  126 CONTINUE
  128 CONTINUE
  130 CONTINUE
  190 CONTINUE
      GO TO 300
CCCCC
CCCCC      NUCLEON SCATERING CASE
CCCCC
  200 DO 240 NH=1,INTRAN
      RH=XMESH*FLOAT(NH)
      RHSQ=RH*RH
      FMU=(RBSQ+R1SQ-RHSQ)/R1RB2
      IF(ABS(FMU).GT.1.0) GO TO 240
      WGT1=-1.0/(RB*R1*RH)
      FMU2=(R1*FMU-RB)/RH
      IF(ABS(FMU2).GT.1.0) GO TO 240
      KP1=3
      FFMU2=FMU2
      CALL YLCAL(FFMU2,KP1,KP1,P)
      DO 212 LAM2P1=1,KP1
      DO 212 M1    =1,LAM2P1
  212 PP(LAM2P1,M1)=P(LAM2P1,M1)
      FFMU=FMU
      CALL YLCAL(FFMU,LPP1MX,LPP1MX,P)
      DO 230 KF=1,KFMAX
      NLS=NLSKFD(KF)
      LP1=L1KFD(KF)+1
      KP1=KKFD(KF)+1
      H1=KP1*2-1
      FAC2=FAC1*WGT1*SQRT(H1)
      M2X=MIN0(KP1,LP1)
      DO 228 M2=1,M2X
      C1=CLEBQ(KF,M2)
      FAC3=FAC2*PP(KP1,M2)*P(LP1,M2)*C1
      QA(KF,NH)=QA(KF,NH)+TRHO(N1,NLS)*FAC3
  228 CONTINUE
  230 CONTINUE
  240 CONTINUE
  300 CONTINUE
CCCCC
CCCCC       R1 LOOP ENDS
CCCCC
      DO 315 NLT=1,NOLTR
  315 GGRI(NLT,NBM)=0.0
      DO 320 KF=1,KFMAX
      IT=ITKFD(KF)
      L1=L1KFD(KF)
      LT=LTKFD(KF)
      NLT=NLTKFD(KF)
      H1=1.0/FLOAT(LT*2+1)
      S1=(-1.0)**L1
c      S2=(-1.0)**((LT-KPARIT)/2)
      H2=SQRT(H1)*S1 !*S2
      K=KKFD(KF)
      NI1=IT*3+(K/2)+IS+1
      NI2=NI1+6
      F1=2.0
      CONST=XMESH/3.
      DO 318 NH=1,INTRAN
      RHO1=XMESH*FLOAT(NH)
      RHO1SQ=RHO1*RHO1
      FSP(NH)=QA(KF,NH)
      F1=6.0-F1
      E1=1.
      URI1=VV(NH,NI1)+VV(NH,NI2)*TTI
      GGRI(NLT,NBM)=GGRI(NLT,NBM)+FSP(NH)*H2*F1*
     1        RHO1SQ*CONST*URI1*E1
  318 CONTINUE
  320 CONTINUE
CCCCCC
CCCCC       RB LOOP ENDS
CCCCC
  900 CONTINUE
CCCCC
      IF(KTLOUT(3).NE.0) THEN
	NBMMX=NBM
      WRITE(8,840)
	DO 350 NLT=1,NOLTR
      WRITE(8,841) NLT,(GGRI(NLT,NBM),NBM=1,NBMMX)
  350 CONTINUE
      ENDIF
  840 FORMAT(/1H ,'DIRECT FORM FACTORS AS A FUNCTION OF RB')
  841 FORMAT(1H  ,5X,'NLT=',I3,/(5X,10E10.3)) 
CCCCC
CCCCC      SECTION 7. CALCULATE THE DIRECT TRANSITION AMPLITDES
CCCCC  
      CALL PACALD(1)
CCCCC
      RETURN
      END
CCCCCC
CCCCCC
      SUBROUTINE PACALD(IDEXCH)
CCCCCC
      PARAMETER(NHS=9,NPS=9,LXA=150,LXB=150,LPH=20,LMM=4,LTL=9)
      PARAMETER(NXA=420,NXB=140,NIN=300,NOU=300,N1X=140)
      PARAMETER(KFM=10,KAA=40,KBB=30,KCC=80,KGG=125,KJL=1000,KTEN=5000)
      PARAMETER(LMJ=10,LRP=11,L1X=10,L2X=60,LM1=5,LM2=30,LAB=2000)
CCCCCC
      COMMON/CNST  /FACLOG(500),PI,HBAR,AMAS,WNUNIT,FINE
      COMMON/CNTRL/ KTRLD(9),KTLOUT(24),KRTYPE
      COMMON/SPSTAT/EET,SPECTA(LPH),ESP(LPH),ESH(LPH),NSP(LPH),LSP(LPH),
     1              JTWP(LPH),NSH(LPH),LSH(LPH),JTWH(LPH),IPAIR,NOSP,
     2              NOSH,NPST(LPH),NHST(LPH),NPAIRD,L1R(8),ISR(8),
     3              ITR(8),NLSMAX,JT,MJMAX,KPARIT,IST,NOLTR,N1,LTR(8),
     4              ITP(LPH),ITH(LPH),ITZP(LPH),ITZH(LPH)
      COMMON/DWCC/  LDWMIR(4),LDWMXR(4),WN(4),LDWSTR(4),CE(4),CFUNIR(4),
     1              ECM(4),XMESR(4),NXMXR(4),NXMIR(4),NOEXP,MXSTEP,
     2              TMASA,TMASB,TMASX,TMASY,PMASA,PMASB,PMASX,PMASY,
     3              TZA,TZB,TZX,TZY,
     4              PZA,PZB,PZX,PZY,XBARD(4),XBARID(4)
      COMMON/DISW / DISWB(LXB*NXB),DISWA(LXA*NXA)
      COMPLEX       DISWB,DISWA
      COMMON/ANGCC/ THEB,THEBMX,DTHEB,THMIN,THMAX,THIND
      COMMON/FFCC/  VRANG(6),VSTR(12,6),VV(NIN,12),XMESH,XMESHD,XMESHE,
     1              RHED(NIN),NBCMI,NBCMX,NONB,NBSTEP,LASTEP,LBSTEP,
     2              MXMAX,MP1MAX,NOLA,NOLB,INTRAN,KCETN(2),NONA,NONAH,
     3              NONAR,NASTEP,NHDMX,NHEMX,NGAUSR,NBSTPD,NBSTPE,
     4              N1STEP,JATW,ISATW
      COMMON/CCKF/  L1KFD(KFM),ISKFD(KFM),KKFD(KFM),LTKFD(KFM),KFMAX,
     1              ITKFD(KFM),NLSKFD(KFM),NLTKFD(KFM),LTMIM,LTMAX
      COMMON/CGGR/  GGRI(L1X,N1X)
      COMPLEX       GGRI
      COMMON/OVDE/  OVDD(50,10,10),OVED(50,10,10),TH(50),DELWN(50)
      COMPLEX       OVDD,OVED                               
      COMMON/AMPL/  AMPD(700,8),AMPE(700,8)
      COMPLEX       AMPD,AMPE
CCCCCC
      DIMENSION     NLTD(KJL),LAD(KJL),LBD(KJL),LTD(KJL),NND(KJL)
      DIMENSION     CLEBD(KJL,10) 
      DIMENSION     P(130,30),PP(130,10)
      DIMENSION     AF(500),AFI(500),XAF(500),XIAF(500),FSP(500),
     1              FSPI(500),Q1(500),AU(500)
      DIMENSION     FLA(10),FGR(10),FAN(10),FGE(10)
	DIMENSION     AMPDW(LXA,4,4),AMPEW(LXA,4,4)
      COMPLEX       FFRI,URI1,ZERO,TTI,AMPDW,AMPEW
	DOUBLE PRECISION TT1,TTH
CCCCC
CCCCC
      TTI=(0.0,1.0)
	ZERO=(0.0,0.0)
      NDWB=15
      LAP1MI=LDWMIR(1)+1
      LAP1MX=LDWMXR(1)+1
      LBP1MI=LDWMIR(2)+1
      LBP1MX=LDWMXR(2)+1
      LASTEP=LDWSTR(1)
      IF(LASTEP.EQ.0)  LASTEP=1
      NOLA=(LAP1MX-LAP1MI)/LASTEP+1
      LAP1MX=LAP1MI+(NOLA-1)*LASTEP
      PAI=PI
      SQ4PAI=SQRT(PAI*4.0)
      NXMAX=NXMXR(1)
      NXMIN=NXMIR(1)
      NONAW=NXMAX-NXMIN+1
      NONBW=NXMXR(2)-NXMIR(2)+1
      NXMAX2=NXMAX+2
      NXMX=NXMAX2
      NXMN=1
      XMESA=XMESR(1)
      XMESB=XMESR(2)
      CONST=(SQ4PAI**2)/(WN(1)*WN(2))
      LTMAX=LTR(NOLTR)
      LTMIN=LTR(1)
CCCCC
      JLS=0
      LAMI=LAP1MI-1
      LBMI=LBP1MI-1
      ID=0
      MP1MAX=MIN0(LTMAX+1,MXMAX+1)
      LBLTMX=NOLTR*NOLB
      LBKFOT=32
      LAMOUT=(NOLA+1)/2
      LTOUT=LTKFD(1)
      LAM=0
      DO 78 LAP1=LAP1MI,LAP1MX,LASTEP
      LA=LAP1-1
      LAM=LAM+1
      LATW=LA*2
      IA=LATW
      H1=LATW+1
      HAT=SQRT(H1)
      DO 77 NLT=1,NOLTR
      LT=LTR(NLT)
      LTP1=LT+1
      LTTW=LT*2
      IC=LTTW
      MP1MXT=MIN0(MP1MAX,LTP1)
      DO 75 LBP1=LBP1MI,LBP1MX
      LBM=LBP1-LBP1MI+1
      LB=LBP1-1
      IF(LB.LT.IABS(LA-LT)) GO TO 75
      IF(LB.GT.LA+LT      )  GO TO 75
      IF(MOD(LA+LB+KPARIT,2).EQ.1) GO TO 75
      JLS=JLS+1
      K1=IABS(LA-LB+KPARIT)/2
      S1=(-1.0)**K1
      IB=LB*2
      H2=IC+1
      H3=(IA+1)*(IB+1)
      H4=SQRT(H3/H2)
      CALL CLEBZ(IA,IB,IC,FACLOG,RAC)
      C1=RAC*H4
      LAD(JLS)=(LAM-1)*NONAW
      LBD(JLS)=(LB-LBMI)*NONBW
      LTD(JLS)=LT
      NLTD(JLS)=NLT
      NND(JLS)=(LB-LBMI)*NOLTR+NLT
      DO 74 M1=1,MP1MXT
   60 CONTINUE
      IE=(M1-1)*2
      IFF=IE
      CALL CLEB(IA,IB,IC,ID,IE,IFF,FACLOG,RAC)
      CLEBD(JLS,M1)=RAC*HAT*S1*C1
   74 CONTINUE
   75 CONTINUE
   76 CONTINUE
   77 CONTINUE
   78 CONTINUE
      JLSMX=JLS
	IF (KTLOUT(3).NE.0) THEN
      WRITE(8,879) JLSMX
  879 FORMAT(1H ,5X,'JLSMX IN PACALD=',4I6//1H )
      ENDIF
CCCCC
      DO 120 LBLT=1,LBLTMX
      DO 120 M1=1,MP1MAX
      IF(IDEXCH.EQ.1) AMPD(LBLT,M1)=(0.0,0.0)
      IF(IDEXCH.EQ.2) AMPE(LBLT,M1)=(0.0,0.0)
  120 CONTINUE
      F1B=2.0
      NB=NBCMI+NBSTEP
      N1=0
      NONBM=NONB-3
      NONBT=NBCMX-NBCMI+1
      XMESA3=XMESA/3.0
      XMESB3=XMESB/3.0
      XFAC3=XMESB3*CONST
CCCCC
      NMAX1=NONB
      NBINT=(NONB-1)*NBSTEP+1
      NBMAX=NBCMI+NBINT-1
      NBM=0
      DO 210 NB=NBCMI,NBMAX
      NBM=NBM+1
      XIAF(NBM)=XMESB*FLOAT(NB)
  210 CONTINUE
      DO 300 JLS=1,JLSMX
      NB2=LBD(JLS)
      NA2=LAD(JLS)
      NLT=NLTD(JLS)
      LBLT=NND(JLS)
      NB=NBCMI-NBSTEP
      DO 220 NBM=1,NONB
      NB=NB+NBSTEP
      AF (NBM)= GGRI(NLT,NBM)
      AFI(NBM)=-GGRI(NLT,NBM)*TTI
      XAF(NBM)=XMESB*FLOAT(NB)
  220 CONTINUE
      NGINT=NBINT
      CALL DSPLS3(XAF,AF  ,NMAX1,XIAF,FSP ,NGINT,Q1,AU,1)
      CALL DSPLS3(XAF,AFI ,NMAX1,XIAF,FSPI,NGINT,Q1,AU,1)
      NB=NBCMI-1
      F1B=2.0
      DO 290 NBM=1,NBINT
      NB=NB+1
      F1B=6.0-F1B
      NB1=NB2+NB
      NA1=NA2+NB
      FFRI=FSP(NBM)+FSPI(NBM)*TTI
      RB=XMESB*FLOAT(NB)
      URI1=FFRI*F1B*XFAC3*DISWA(NA1)*DISWB(NB1)/(RB*RB)
      DO 260 M1=1,MP1MAX
      C1=CLEBD(JLS,M1)
      IF(IDEXCH.EQ.1) AMPD(LBLT,M1)=AMPD(LBLT,M1)+URI1*C1
      IF(IDEXCH.EQ.2) AMPE(LBLT,M1)=AMPE(LBLT,M1)+URI1*C1
  260 CONTINUE
  270 CONTINUE
  280 CONTINUE
  290 CONTINUE
  300 CONTINUE
CCCCCC
      IF (KTLOUT(3).NE.0) THEN
      LBLT=0
      DO 450 LBP1=LBP1MI,LBP1MX
	DO 440 NLT=1,NOLTR
        LBLT=LBLT+1
        DO 430 M1=1,MP1MAX
      IF(IDEXCH.EQ.1) AMPDW(LBP1,NLT,M1)=AMPD(LBLT,M1)
      IF(IDEXCH.EQ.2) AMPEW(LBP1,NLT,M1)=AMPE(LBLT,M1)
  430   CONTINUE 
  440 CONTINUE
  450 CONTINUE
      DO 480 NLT=1,NOLTR
	DO 470 M1=1,MP1MAX
      IF(IDEXCH.EQ.1) THEN
	IF (M1.LE.(LTR(NLT)+1)) THEN
	WRITE(8,808) NLT,M1
      WRITE(8,810) (AMPDW(LBP1,NLT,M1),LBP1=LBP1MI,LBP1MX)
	ENDIF 
      ELSE
	IF (M1.LE.(LTR(NLT)+1)) THEN
	WRITE(8,809) NLT,M1
      WRITE(8,810) (AMPEW(LBP1,NLT,M1),LBP1=LBP1MI,LBP1MX) 
	ENDIF
	ENDIF
  470 CONTINUE
  480 CONTINUE
      ENDIF
  808 FORMAT(/1H ,5X,'AMPD(LBP1,NLT,M1) AT NLT,M1=',2I3)
  809 FORMAT(/1H ,5X,'AMPE(LBP1,NLT,M1) AT NLT,M1=',2I3)
  810 FORMAT(1H ,5X,10E10.3)
CCCCCC
      NTHETA=(THEBMX-THEB)/DTHEB+1. 
	DO 580 NTH=1,NTHETA
	THETA = THEB+FLOAT(NTH-1)*DTHEB
      TH(NTH)=THETA*PI/180.0
	DELWN(NTH)=SQRT(WN(1)**2+WN(2)**2-2.0*WN(1)*WN(2)*COS(TH(NTH)))
      TTH=TH(NTH)
      TT1=DCOS(TTH)
      CALL YLCAL(TT1,LBP1MX,MP1MAX,P)
CCCCC
      DO 510 NLT=1,NOLTR
      DO 510 M1=1,MP1MAX
      IF (IDEXCH.EQ.1) OVDD(NTH,NLT,M1)=ZERO
      IF (IDEXCH.EQ.2) OVED(NTH,NLT,M1)=ZERO
  510 CONTINUE  
CCCCC
      LBLT=0
      DO 577 LBP1=LBP1MI,LBP1MX
	DO 575 NLT=1,NOLTR
        LBLT=LBLT+1
        DO 570 M1=1,MP1MAX
          IF(IDEXCH.EQ.1) OVDD(NTH,NLT,M1)=OVDD(NTH,NLT,M1)
     1                                  +AMPD(LBLT,M1)*P(LBP1,M1)
          IF(IDEXCH.EQ.2) OVED(NTH,NLT,M1)=OVED(NTH,NLT,M1)
     1                                  +AMPE(LBLT,M1)*P(LBP1,M1)
  570   CONTINUE 
  575 CONTINUE
  577 CONTINUE
  580 CONTINUE
CCCCCC
      IF (KTLOUT(3).NE.0) THEN
	IF (IDEXCH.EQ.1) WRITE(8,880)
	IF (IDEXCH.EQ.2) WRITE(8,881)
      DO 590 NLT=1,NOLTR                                                
      LT=LTR(NLT) 
	DO 585 NTH=1,NTHETA 
	THETA=TH(NTH)*180.0/PI                                                    
      IF(IDEXCH.EQ.1) WRITE(8,882)  THETA, DELWN(NTH),LT,
     1                              (OVDD(NTH,NLT,M1),M1=1,MP1MAX)
      IF(IDEXCH.EQ.2) WRITE(8,882)  THETA, DELWN(NTH),LT,
     1                              (OVED(NTH,NLT,M1),M1=1,MP1MAX)
  585 CONTINUE
  590 CONTINUE
      ENDIF

  880 FORMAT(//1H ,'DIRECT TRANSITION AMPLITUDES'/)
  881 FORMAT(//1H ,'EXCHANGE TRANSITION AMPLITUDES (NO-RECOIL APPRO.)'/)
  882 FORMAT(1H ,'THETA, DEL K, LT=',2F8.3,I3,2X,10E10.3)                         
CCCCCC
      RETURN
      END